;
;- -----------------------------------------------------------
;
; PureBasic - Basic Window Example
;- With minimize/maximize and close buttons
;
; (c) 2002 - Fantaisie Software
;
;- -----------------------------------------------------------
;

Procedure timer1()
  Global Value.l
  Value = Value + 1
  beep_(1800, 5) ; WinAPI function
  FreeGadget(5) ; must free the gadget, before re-creating
  TextGadget(5, 130, 40, 30, 20, Str(Value))
  
EndProcedure


If OpenWindow(0, 100, 100, 295, 260, #PB_Window_WindowCentered | #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget, "Timer Window with Buttons")
  If CreateGadgetList(WindowID())
    
    ButtonGadget(1, 100, 80, 80, 30, "Start Timer")
    ButtonGadget(2, 100, 150, 80, 30, "Stop Timer")
    TextGadget(3, 55, 40, 70, 20, "Timer ran for:")
    TextGadget(4, 150, 40, 60, 20, "seconds")
    
    
  EndIf
  
  ;
  ; This is the 'event loop'. All the user actions are processed here.
  ; It's very easy to understand: when an action occurs, the EventID
  ; isn't 0 and we just have to see what have happened...
  ;
  
  Repeat
    EventID.l = WaitWindowEvent()
    
    If EventID = #PB_EventGadget
      
      Select EventGadgetID()
          
        Case 1 ; Start button
          StartTimer(1, 1000, @timer1()) ; executes the Timer1() procedure
          
        Case 2 ; Stop button
          EndTimer(1)
          Value = 0
      EndSelect
      
    EndIf
    
    If EventID = #PB_Event_CloseWindow ; If the user has pressed on the close button at top of Window
      Quit = 1
    EndIf
    
  Until Quit = 1
  
EndIf

End ; All the opened windows are closed automatically by PureBasic

; ExecutableFormat=Windows
; FirstLine=1
; EnableAsm
; EnableNT4
; Executable=C:\PureBasic\Starter\Basic Timer.exe
; DisableDebugger
; EOF