; ------------------------------------------------
; Count words in a text file or whatever.
; By Pupil 2/11 -2002
; ------------------------------------------------

Structure Chartype
  StructureUnion
    c.b
    a.b[2]
    w.w
  EndStructureUnion
EndStructure

Structure UniqueWordsType
  Word.s
  Count.l
EndStructure

Global UniqueWords.l, TotalWords, TotalLines.l
Dim hash.l(65536)
Dim charhash.b(255)
NewList WordCount.UniqueWordsType()

Declare ParseString(*ptr.CharType)
Declare SortWords()

; Sort the linked list and store result in an array.
Procedure SortWords()
DefType.b i, j
DefType.w count, comp
DefType.l arraycount
DefType.CharType *pcount, *pcomp
  Dim UniqueWordArray.UniqueWordsType(UniqueWords)
  arraycount = 0
  *pcount = @count : *pcomp = @comp
  For j = 0 To 'z'
      *pcount\a[0] = j
    For i = 0 To 'z'
      *pcount\a[1] = i
      If hash(count)
        ChangeCurrentElement(WordCount(), hash(count))
        hash(count) = 0 ; clear hash for next file
        Repeat
          UniqueWordArray(arraycount)\Word = WordCount()\Word
          UniqueWordArray(arraycount)\Count = WordCount()\Count
          arraycount + 1
          If NextElement(WordCount()) = 0
            *pcomp = @comp
          Else
            *pcomp = @WordCount()\Word
          EndIf
        Until *pcomp\w <> count
      EndIf
    Next
  Next
  ClearList(WordCount()) ; clear linked list to prepare for next file
EndProcedure

; Count lines, words and unique words and
; store those unique ones in a list.
Procedure ParseString(*ptr.CharType)
DefType.l start, quit
DefType.s word
DefType.CharType *p, *d
  start = *ptr
  While *ptr\c <> 0
    If charhash(*ptr\c)
      start = *ptr
      Repeat
        *ptr+1
      Until charhash(*ptr\c) = #FALSE Or *ptr\c = 0
      word = LCase(PeekS(start, *ptr-start))
      If word <> ""
        *p = @word
        TotalWords+1
        If hash(*p\w)
          ChangeCurrentElement(WordCount(), hash(*p\w))
          quit = #FALSE
          Repeat
            *d = @WordCount()\Word
            If WordCount()\Word < word And *d\w = *p\w
              If NextElement(WordCount()) = 0
                AddElement(WordCount())
                WordCount()\Word = word
                WordCount()\Count = 1
                UniqueWords + 1
                quit = #TRUE
              EndIf
            Else
              If WordCount()\Word = word
                WordCount()\Count+1
                quit = #TRUE
              Else
                start = @WordCount()
                InsertElement(WordCount())
                WordCount()\Word = word
                WordCount()\Count = 1
                UniqueWords + 1
                If start = hash(*p\w)
                  hash(*p\w) = @WordCount()
                EndIf
                quit = #TRUE
              EndIf
            EndIf
          Until quit
        Else
          ResetList(WordCount())
          AddElement(WordCount())
          WordCount()\Word = word
          WordCount()\Count = 1
          UniqueWords + 1
          hash(*p\w) = @WordCount()
        EndIf
      EndIf
    ElseIf *ptr\c = 13
      TotalLines+1
      *ptr+2
    ElseIf *ptr\c = 10
      TotalLines+1
      *ptr+1
    Else 
      *ptr+1
    EndIf
    If TotalLines-(TotalLines/2500)*2500 = 0
            StatusBarText(0, 0, "Parsing line #" + Str(TotalLines) + " ... found " + Str(TotalWords) + " words.", 0)
        EndIf
  Wend
  StatusBarText(0, 0, "Parsing line #" + Str(TotalLines) + " ... found " + Str(TotalWords) + " words.", 0)
EndProcedure

; create hash for valid characters
For i = 0 To 255
  If (i >= 'A' And i <= 'Z') Or (i >= 'a' And i <= 'z') Or i = 39
    charhash(i) = #TRUE
  Else
    charhash(i) = #FALSE
  EndIf
Next

; --------------------------------------------------------
; GUI interface borrowed from fweil, hope you don't mind..
; --------------------------------------------------------

Quit.l = #FALSE
EOL.s = Chr(13)+Chr(10)

If OpenWindow(0, 200, 200, 320, 240, #PB_Window_SystemMenu | #PB_Window_TitleBar, "Word Count")

  AddKeyboardShortcut(0, #PB_Shortcut_Escape, 99)

  If CreateMenu(0, WindowID())
    OpenSubMenu("General")
      MenuItem(11, "Open file")
      MenuItem(99, "Quit")
    CloseSubMenu()
  EndIf

  If CreateStatusBar(0, WindowID())
    StatusBarText(0, 0, "Idle ...", 0)
  EndIf

  If CreateGadgetList(WindowID())
    TextGadget(100, 10, 10, 300, 160, "")
  EndIf

  SetGadgetText(100, "Select a file to process ...")

; main message loop
  Repeat
    Select WaitWindowEvent()
      Case #PB_EventCloseWindow
        Quit = #TRUE
      Case #PB_EventMenu
        Select EventMenuID()
          Case 11
            fileName.s = OpenFileRequester("Select a file", "*.txt", "Text files|*.txt|All files|*.*", 0)
            tz.l = GetTickCount_()
            If ReadFile(0, filename)
              length.l = Lof()
              *buffer = AllocateMemory(0, length+2)
              If *buffer
                UniqueWords = 0 : TotalWords = 0 : TotalLines = 0
                ReadData(*buffer, length)
                ParseString(*buffer)
                FreeMemory(0)
              EndIf
              CloseFile(0)
              SortWords()
            EndIf
            SetGadgetText(100, "File: "+fileName+EOL+"Lines: "+Str(TotalLines)+EOL+"Words: "+Str(TotalWords)+EOL+"Unique wods: "+Str(UniqueWords)+EOL+"Done in "+Str(GetTickCount_() - tz)+"ms")
            If CreateFile(1, "UniqueWords.txt")
              WriteStringN("Lines: "+Str(TotalLines))
              WriteStringN("Words: "+Str(TotalWords))
              WriteStringN("Unique words: "+Str(UniqueWords))

              For i = 0 To UniqueWords-1
                WriteStringN(Str(i)+" "+UniqueWordArray(i)\Word+Chr(9)+Chr(9)+Str(UniqueWordArray(i)\Count))
              Next
              CloseFile(1)
              ShellExecute_(hWnd,"open","UniqueWords.txt","","",#SW_SHOWNORMAL)
            EndIf
          Case 99
            Quit = #TRUE
        EndSelect
    EndSelect
  Until Quit
EndIf
End
; ExecutableFormat=Windows
; FirstLine=1
; DisableDebugger
; EOF