; ----------------------------------------------------------------------------
;
; A little program to demonstrate how to print at the same
; location on all printers.  It converts X/Y position in Millimeters
; to the X/Y position in Pixels.
; This allows you to design your print layout with a Metric Ruler.
;
; If I want to print text 10mm down and 20mm over from the edge of the print
; canvas, I can use Locate(10*px,20*py)
;
; If I want to print a 10mm x 10mm box at location 80mm down and 50mm over
; from the edge of the print canvas, I would use Box(80*px,50*py,10*px,10*py) 
;
; Always multiply the X position in millimeters that you want by px
; Always multiply the Y position in millimeters that you want by py
;
; (It's very difficult to get perfect measurements because every printer
; has a slightly different sized print area... but you will find that this
; formula gives you the best results across many printers)
;
; I have found though, that there is little control over fonts when printing
; to a Laser Printer... possible bug in Printer library?
; Author - unknown
; ----------------------------------------------------------------------------
#pagex=204
#pagey=260


If PrintRequester()
  printerwidth=PrinterPageWidth()
  printerheight=PrinterPageHeight()
  px.f=printerwidth/#pagex
  py.f=printerheight/#pagey    
  pica.f=px*2.75
  row=10
  col=10
        
  If StartPrinting("PrintJob")  
    If StartDrawing(PrinterOutput())
      DrawingFont(LoadFont(0, "Arial", pica))
      UseFont(0)

      For tmp=1 To 10
        Box(2*px,row*py,2*px,2*py)
        Locate(col*px,row*py)
        DrawText("Print Position: "+Str(col)+"mm x "+Str(row)+"mm")
        col+10 
        row+10     
      Next 
      
      CloseFont(0)
      StopDrawing()      
    EndIf    
    StopPrinting()          
  EndIf        
  MessageRequester("Print","Data has been sent to Printer",#MB_ICONINFORMATION)  
EndIf
End
; ExecutableFormat=Windows
; FirstLine=1
; UseIcon=C:\Utilities\PureBasic\icons\utils\COPY03E.ICO
; Executable=D:\archive\View Monthly Stats.exe
; DisableDebugger
; EOF