; ------------------------------------------------------------
;  PickColor.pb - Colors to your clipboard
;     
;                 Sometimes when working with the Windows API
;                 you'd like to see colors in HEX. 
;                 Sometimes you'd like RGB colors.

;                 This small program allows you to choose and
;                 place the color info to the clipboard. Simply
;                 paste the results into your program.
;                 Public Domain              Aug. 2002 - blueb
;
; ------------------------------------------------------------

; Declarations
Global hWnd.l
Global ColorSpec.CHOOSECOLORAPI  ;Note: This is a Windows API structure
Dim CustomColor.l(15)

Normal.l = LoadFont(0, "Arial", 9)
Bold.l = LoadFont(1, "Arial Bold", 10)

#WindowWidth  = 250
#WindowHeight = 80
 
; --------------------------------------------------------------------------
Procedure.l UpdateClipBoard(Result.s)
    hGout.l
    mx.l
    Result.s
      hGout = GlobalAlloc_(#GMEM_MOVEABLE |#GMEM_ZEROINIT |#GMEM_DDESHARE, @Result)
      Mx = GlobalLock_(hGout)
      PokeS(Mx, Result)
      GlobalUnLock_(hGout)
      If OpenClipBoard_(hWnd)
           EmptyClipBoard_()
              SetClipBoardData_(#CF_TEXT, hGout)
           CloseClipBoard_()
          ; GlobalFree_(hGout)  Note: From MSDN...you should not free the handle, 
          ;                     as that handle is now the property of Windows.
      EndIf
EndProcedure
; ---------------------------------------------------------------------------

If OpenWindow(0, 100, 150, #WindowWidth, #WindowHeight, #PB_Window_WindowCentered | #PB_Window_MinimizeGadget, "PickColor")
 hWnd = WindowID()
 If CreateGadgetList(WindowID())
   
  ;Add text gadget
  SetGadgetFont(0, Bold) 
  TextGadget(0, 5, 8, 200, 18, "Select Color Preference:")
  
  ;Add option buttons
  SetGadgetFont(0, Normal)
  OptionGadget(1,  50,  32, 150, 10, "Returns HEX Color")
  OptionGadget(2,  50,  52, 150, 10,  "Returns RGB Color") 
  
  ;Event loop 
  Repeat
    EventID = WaitWindowEvent()
     
     If EventID = #PB_EventGadget

      Select EventGadgetID()
          
          Case 1  ; HEX ColorRequester
                  ; Places a new assortment of colors in the custom boxes
                  ; each time the option button is pressed. 
                  For Counter.l = 0 To 15 
                      CustomColor(Counter) = Random(16777215) 
                  Next
            
                  ColorSpec\lStructSize  = SizeOf(CHOOSECOLORAPI)
                  ColorSpec\hwndOwner    = hWnd
                  ColorSpec\lpCustColors = @CustomColor(0)
                  ColorSpec\Flags = #CC_FULLOPEN|#CC_RGBINIT 
                  
                  If ChooseColor_(ColorSpec) 
                      Color=ColorSpec\rgbResult 
                      result.s = "$" + Hex(Color) 
                      MessageRequester("HEX Color:", result, 0)
                      UpdateClipBoard(result) 
                  EndIf
          
                  
          Case 2  ; RGB ColorRequester
                  ; Places a new assortment of colors in the custom boxes
                  ; each time the option button is pressed. 
                  For Counter.l = 0 To 15 
                      CustomColor(Counter) = Random(16777215) 
                  Next
                            
                  ColorSpec\lStructSize = SizeOf(CHOOSECOLORAPI) ;Thanks to Paul   :>)
                  ColorSpec\hwndOwner = hWnd
                  ColorSpec\lpCustColors = @CustomColor(0) 
                  ColorSpec\Flags = #CC_FULLOPEN|#CC_RGBINIT 

                  If ChooseColor_(ColorSpec) 
                      Color=ColorSpec\rgbResult 
                      result.s = "RGB("+Str(Red(Color))+","+Str(Green(Color))+","+Str(Blue(Color))+")" 
                      MessageRequester("RGB Color:", result, 0)
                      UpdateClipBoard(result) 
                  EndIf
        EndSelect
      ;Minimize window and place it on the task bar.  
      res.l = CloseWindow_(hWnd)       
    EndIf

  Until EventID = #PB_EventCloseWindow
  
 EndIf
   
EndIf

End
; ExecutableFormat=Windows
; FirstLine=1
; EnableAsm
; EnableNT4
; Executable=C:\PureBasic\UserSnippets\PickColor.exe
; DisableDebugger
; EOF